/* mbed Microcontroller Library
 * Copyright (c) 2019 ARM Limited
 * SPDX-License-Identifier: Apache-2.0
 */

//#include "mbed.h"
//#include "bibli.h"
#include "mbed.h"
#include "UnbufferedSerial.h"
#include <ctime>

PwmOut servo_mot_tapis(D8);
PwmOut servo_mot_poussoir_bleu(D10);
//PwmOut servo_mot_poussoir_jaune(D11);
PwmOut servo_mot_poussoir_rouge(D6);
char data;
char tab_couleur[10];
int tab_time[10];
int i(0);
    //clock_t sortie, pousse;
Timer t;
int date;

// après, durée rouge est le temps, en us, pour que le cube passe de l'entrée du champ de vision de la caméra au poussoir rouge
// durées à calibrer
int duree_rouge = 5000500; //1.75 secondes entre le temps où le cube sort de la caméra et le temps où il arrive devant le poussoir.

//int duree_vert = 15000;
int duree_bleu = 3005000;

//int duree_jaune = 5000000;

// Si il est de la couleur rouge et qu'il est entré il y a pile le temps qu'il faut pour se retrouver en face du poussoir rouge (à précision près)
// alors on lance le poussoir des rouges
// précision à calibrer
//int precision = 200000;


UnbufferedSerial py_port(USBTX, USBRX);

//Timer t;
//void ISR_my_pc_reception(void);
void test_poussoir(char couleur, int duree);
void poussoir_bleu(PwmOut servo_mot_poussoir1);
void poussoir_rouge(PwmOut servo_mot_poussoir3);
void poussoir_jaune(PwmOut servo_mot_poussoir2);
void ISR_py_port_reception(void);

int main()
{
    t.start();
    //while read

    py_port.baud(115200);
    py_port.attach(&ISR_py_port_reception, UnbufferedSerial::RxIrq);

    
    //servo_mot_poussoir_rouge.period_ms(20);         // Initialisation période

    servo_mot_tapis.period_us(2000);   // contrôler la période de rotation du moteur
    servo_mot_tapis.write(0.5);
    //servo_mot.write(0.5);   // forcer le rapport cyclique à 0.5 (proportion d'état haut par rapport au total)

    
    //poussoir_bleu(servo_mot_poussoir_bleu);
    //poussoir_rouge(servo_mot_poussoir_rouge);

    while(1){



        date = t.elapsed_time().count();

        // date = t.read_us()

        for(int j(0); j < i; j++) {test_poussoir(tab_couleur[j], date - tab_time[i]);}
        //poussoir_rouge(servo_mot_poussoir_rouge);


        }

    

}



void test_poussoir(char couleur, int duree){
    if (couleur == 'R') {wait_us(duree_rouge); poussoir_rouge(servo_mot_poussoir_rouge);}
    //if (couleur == 'J') {wait_us(duree_jaune); poussoir_jaune(servo_mot_poussoir_jaune);}
    //if (couleur = "V") {/*lancer le poussoir vert*/}
    if (couleur == 'B') {wait_us(duree_bleu); poussoir_bleu(servo_mot_poussoir_bleu);}
}

void poussoir_bleu(PwmOut servo_mot_poussoir1)
{
    
    //int i, time = 1500;
    servo_mot_poussoir1.period_ms(5);         // Initialisation période
    servo_mot_poussoir1.pulsewidth_us(700);   // Initialisation en position 0

    while(1){
        servo_mot_poussoir1.pulsewidth_us(2200);   // Angle négatif
        wait_us(900000);
        servo_mot_poussoir1.pulsewidth_us(700);   // Angle positif
        wait_us(900000);
        break;
    }
    
}
//Fonction poussoir 2 (manche bleu foncé)

/*void poussoir_jaune(PwmOut servo_mot_poussoir2)
{
    
    int i, time = 1500;
    servo_mot_poussoir2.period_ms(20);         // Initialisation période
    servo_mot_poussoir2.pulsewidth_us(2200);   // Initialisation en position 0

    while(1){
        servo_mot_poussoir2.pulsewidth_us(700);   // Angle négatif
        wait_us(1200000);
        servo_mot_poussoir2.pulsewidth_us(2200);   // Angle positif
        wait_us(500000);
        break;
    }
    
}*/

//Fonction poussoir 3 (noir)

void poussoir_rouge(PwmOut servo_mot_poussoir3)
{
    
    //int i, time = 1500;
    
    /*servo_mot_poussoir3.period_ms(20);         // Initialisation période
    servo_mot_poussoir3.pulsewidth_us(10);   // Initialisation en position 0

    while(1){
        servo_mot_poussoir3.pulsewidth_us(2000);   // Angle négatif
        wait_us(400000);
        servo_mot_poussoir3.pulsewidth_us(10);   // Angle positif
        wait_us(500000);
        break;
    }*/

    int i, time = 1500;
    servo_mot_poussoir3.period_ms(20);         // Initialisation période
    servo_mot_poussoir3.pulsewidth_us(2500);   // Initialisation en position 0

    while(1){
        servo_mot_poussoir3.pulsewidth_us(700);   // Angle négatif
        wait_us(1200000);
        servo_mot_poussoir3.pulsewidth_us(2500);   // Angle positif
        wait_us(500000);
        break;
    }
    
}

void ISR_py_port_reception(void){
    py_port.read(&data, 1);
    /*if(data == 'S'){ //Stopper le tapis (normalement)
                break;
            }*/
    /*else*/ if(data == 'R' || data == 'J' || data == 'V' || data == 'B') {tab_couleur[i]=data; tab_time[i] = t.elapsed_time().count(); i++;}
    py_port.write(&data, 1);

}